<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex48.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex48.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex48.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex48.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 48: Advanced User Input</h1>
                <p>In past games you handled the user's input by simply expecting set strings.  If the user typed &quot;run&quot;, and exactly &quot;run&quot;, then the game worked. If they typed in similar phrases like &quot;run fast&quot; it would fail.  What we need is a device that lets users type phrases in various ways and then convert that into something the computer understands.  For example, we'd like to have all of these phrases work the same:</p>
<ul class="simple">
<li>open door</li>
<li>open the door</li>
<li>go THROUGH the door</li>
<li>punch bear</li>
<li>Punch The Bear in the FACE</li>
</ul>
<p>It should be alright for a user to write something a lot like English for your game, and have your game figure out what it means.  To do this, we're going to write a module that does just that.  This module will have a few classes that work together to handle user input and convert it into something your game can work with reliably.</p>
<p>In a simple version of English the following elements:</p>
<ul class="simple">
<li>Words separated by spaces.</li>
<li>Sentences composed of the words.</li>
<li>Grammar that structures the sentences into meaning.</li>
</ul>
<p>That means the best place to start is figuring out how to get words from the user and what kinds of words those are.</p>
<div class="section" id="our-game-lexicon">
<h1>Our Game Lexicon</h1>
<p>In our game we have to create a list of allowed words called a &quot;lexicon&quot;:</p>
<ul class="simple">
<li>Direction words:  north, south, east, west, down, up, left, right, back</li>
<li>Verbs: go, stop, kill, eat</li>
<li>Stop words: the, in, of, from, at, it</li>
<li>Nouns: door, bear, princess, cabinet</li>
<li>Numbers: any string of 0 through 9 characters</li>
</ul>
<p>When we get to nouns, we have a slight problem since each room could have a different set of nouns, but let's just pick this small set to work with for now and improve it later.</p>
<div class="section" id="breaking-up-a-sentence">
<h2>Breaking Up a Sentence</h2>
<p>Once we have our lexicon we need a way to break up sentences so that we can figure out what they are.  In our case, we've defined a sentence as &quot;words separated by spaces,&quot; so we really just need to do this:</p>
<pre class="code python literal-block">
<span class="name">stuff</span> <span class="operator">=</span> <span class="name builtin">raw_input</span><span class="punctuation">(</span><span class="literal string single">'&gt; '</span><span class="punctuation">)</span>
<span class="name">words</span> <span class="operator">=</span> <span class="name">stuff</span><span class="operator">.</span><span class="name">split</span><span class="punctuation">()</span>
</pre>
<p>That's all we'll worry about for now, but this will work really well for quite a while.</p>
</div>
<div class="section" id="lexicon-tuples">
<h2>Lexicon Tuples</h2>
<p>Once we know how to break up a sentence into words, we just have to go through the list of words and figure out what &quot;type&quot; they are.  To do that we're going to use a handy little Python structure called a &quot;tuple.&quot;  A tuple is nothing more than a list that you can't modify.  It's created by putting data inside two <tt class="docutils literal">()</tt> with a comma, like a list:</p>
<pre class="code python literal-block">
<span class="name">first_word</span> <span class="operator">=</span> <span class="punctuation">(</span><span class="literal string single">'verb'</span><span class="punctuation">,</span> <span class="literal string single">'go'</span><span class="punctuation">)</span>
<span class="name">second_word</span> <span class="operator">=</span> <span class="punctuation">(</span><span class="literal string single">'direction'</span><span class="punctuation">,</span> <span class="literal string single">'north'</span><span class="punctuation">)</span>
<span class="name">third_word</span> <span class="operator">=</span> <span class="punctuation">(</span><span class="literal string single">'direction'</span><span class="punctuation">,</span> <span class="literal string single">'west'</span><span class="punctuation">)</span>
<span class="name">sentence</span> <span class="operator">=</span> <span class="punctuation">[</span><span class="name">first_word</span><span class="punctuation">,</span> <span class="name">second_word</span><span class="punctuation">,</span> <span class="name">third_word</span><span class="punctuation">]</span>
</pre>
<p>This creates a pair (TYPE, WORD) that lets you look at the word and do things with it.</p>
<p>This is just an example, but that's basically the end result.  You want to take raw input from the user, carve it into words with <tt class="docutils literal">split</tt>, analyze those words to identify their type, and finally make a sentence out of them.</p>
</div>
<div class="section" id="scanning-input">
<h2>Scanning Input</h2>
<p>Now you are ready to write your scanner.  This scanner will take a string of raw input from a user and return a sentence that's composed of a list of tuples with the (TOKEN, WORD) pairings.  If a word isn't part of the lexicon then it should still return the WORD but set the TOKEN to an error token.  These error tokens will tell users they messed up.</p>
<p>Here's where it gets fun.  I'm not going to tell you how to do this.  Instead I'm going to write a &quot;unit test&quot; and you are going to write the scanner so that the unit test works.</p>
</div>
<div class="section" id="exceptions-and-numbers">
<h2>Exceptions and Numbers</h2>
<p>There is one tiny thing I will help you with first, and that's converting numbers.  In order to do this though, we're going to cheat and use exceptions.  An exception is an error that you get from some function you may have run.  What happens is your function &quot;raises&quot; an exception when it encounters an error, then you have to handle that exception.  For example, if you type this into Python:</p>
<div class="highlight"><pre><span></span><a name="python--ex48_pycon.py-idio-pycon-pyg.html-1"></a><span class="go">Python 2.7.11 (default, Jan 22 2016, 23:30:40) </span>
<a name="python--ex48_pycon.py-idio-pycon-pyg.html-2"></a><span class="go">[GCC 4.2.1 Compatible Apple LLVM 7.0.2 (clang-700.1.81)] on darwin</span>
<a name="python--ex48_pycon.py-idio-pycon-pyg.html-3"></a><span class="go">Type &quot;help&quot;, &quot;copyright&quot;, &quot;credits&quot; or &quot;license&quot; for more information.</span>
<a name="python--ex48_pycon.py-idio-pycon-pyg.html-4"></a><span class="gp">&gt;&gt;&gt; </span><span class="nb">int</span><span class="p">(</span><span class="s2">&quot;hell&quot;</span><span class="p">)</span>
<a name="python--ex48_pycon.py-idio-pycon-pyg.html-5"></a><span class="gt">Traceback (most recent call last):</span>
<a name="python--ex48_pycon.py-idio-pycon-pyg.html-6"></a>  File <span class="nb">&quot;&lt;stdin&gt;&quot;</span>, line <span class="m">1</span>, in <span class="n">&lt;module&gt;</span>
<a name="python--ex48_pycon.py-idio-pycon-pyg.html-7"></a><span class="gr">ValueError</span>: <span class="n">invalid literal for int() with base 10: &#39;hell&#39;</span>
</pre></div><p>That <tt class="docutils literal">ValueError</tt> is an exception that the <tt class="docutils literal">int()</tt> function threw because what you handed <tt class="docutils literal">int()</tt> is not a number.  The <tt class="docutils literal"><span class="pre">int())</span></tt> function could have returned a value to tell you it had an error, but since it only returns integers, it'd have a hard time doing that.  It can't return -1 since that's a number.  Instead of trying to figure out what to return when there's an error, the <tt class="docutils literal">int()</tt> function raises the <tt class="docutils literal">ValueError</tt> exception and you deal with it.</p>
<p>You deal with an exception by using the <tt class="docutils literal">try</tt> and <tt class="docutils literal">except</tt> keywords:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>1
2
3
4
5</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex48_convert.py-idio.html-1"></a><span class="k">def</span> <span class="nf">convert_number</span><span class="p">(</span><span class="n">s</span><span class="p">):</span>
<a name="python--ex48_convert.py-idio.html-2"></a>    <span class="k">try</span><span class="p">:</span>
<a name="python--ex48_convert.py-idio.html-3"></a>        <span class="k">return</span> <span class="nb">int</span><span class="p">(</span><span class="n">s</span><span class="p">)</span>
<a name="python--ex48_convert.py-idio.html-4"></a>    <span class="k">except</span> <span class="ne">ValueError</span><span class="p">:</span>
<a name="python--ex48_convert.py-idio.html-5"></a>        <span class="k">return</span> <span class="bp">None</span>
</pre></div>
</td></tr></table><p>You put the code you want to &quot;try&quot; inside the <tt class="docutils literal">try</tt> block, and then you put the code to run for the error inside the <tt class="docutils literal">except</tt>.  In this case, we want to &quot;try&quot; to call <tt class="docutils literal">int()</tt> on something that might be a number.  If that has an error, then we &quot;catch&quot; it and return <tt class="docutils literal">None</tt>.</p>
<p>In your scanner that you write, you should use this function to test if something is a number.  You should also do it as the last thing you check for before declaring that word an error word.</p>
</div>
</div>
<div class="section" id="a-test-first-challenge">
<h1>A Test First Challenge</h1>
<p>Test first is a programming tactic where you write an automated test that pretends the code works, <em>then</em> you write the code to make the test actually work.  This method works when you can't visualize how the code is implemented, but you can imagine how you have to work with it.  For example, if you know how you need to use a new class in another module, but you don't quite know how to implement that class yet, then write the test first.</p>
<p>You are going to take a test I give you and use it to write the code that makes it work.  To do this exercise you're going to follow this procedure:</p>
<ol class="arabic simple">
<li>Create one small part of the test I give you.</li>
<li>Make sure it runs and <em>fails</em> so you know that the test is actually confirming a feature works.</li>
<li>Go to your source file <tt class="docutils literal">lexicon.py</tt> and write the code that makes this test pass.</li>
<li>Repeat until you have implemented everything in the test.</li>
</ol>
<p>When you get to 3 it's also good to combine our other method of writing code:</p>
<ol class="arabic simple">
<li>Make the &quot;skeleton&quot; function or class that you need.</li>
<li>Write comments inside describing how that function works.</li>
<li>Write the code that does what the comments describe.</li>
<li>Remove any comments that just repeat the code.</li>
</ol>
<p>This method of writing code is called &quot;psuedo code&quot; and works well if you don't know how to implement something, but you can describe it in your own words.</p>
<p>Combining the &quot;test first&quot; with the &quot;psuedo code&quot; tactics we have this simple process for programming:</p>
<ol class="arabic simple">
<li>Write a bit of test that fails.</li>
<li>Write the skeleton function/module/class the test needs.</li>
<li>Fill the skeleton with comments in your own words explaining how it works.</li>
<li>Replace the comments with code until the test passes.</li>
<li>Repeat.</li>
</ol>
<p>In this exercise you will practice this method of working by making a test I give you run against the <tt class="docutils literal">lexicon.py</tt> module.</p>
</div>
<div class="section" id="what-you-should-test">
<h1>What You Should Test</h1>
<p>Here is the test case <tt class="docutils literal">tests/lexicon_tests.py</tt> that you should use, but <em>don't type this in yet</em>:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--lexicon_tests.py-idio.html-1"></a><span class="kn">from</span> <span class="nn">nose.tools</span> <span class="kn">import</span> <span class="o">*</span>
<a name="python--lexicon_tests.py-idio.html-2"></a><span class="kn">from</span> <span class="nn">ex48</span> <span class="kn">import</span> <span class="n">lexicon</span>
<a name="python--lexicon_tests.py-idio.html-3"></a>
<a name="python--lexicon_tests.py-idio.html-4"></a>
<a name="python--lexicon_tests.py-idio.html-5"></a><span class="k">def</span> <span class="nf">test_directions</span><span class="p">():</span>
<a name="python--lexicon_tests.py-idio.html-6"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;north&quot;</span><span class="p">),</span> <span class="p">[(</span><span class="s1">&#39;direction&#39;</span><span class="p">,</span> <span class="s1">&#39;north&#39;</span><span class="p">)])</span>
<a name="python--lexicon_tests.py-idio.html-7"></a>    <span class="n">result</span> <span class="o">=</span> <span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;north south east&quot;</span><span class="p">)</span>
<a name="python--lexicon_tests.py-idio.html-8"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="p">[(</span><span class="s1">&#39;direction&#39;</span><span class="p">,</span> <span class="s1">&#39;north&#39;</span><span class="p">),</span>
<a name="python--lexicon_tests.py-idio.html-9"></a>                          <span class="p">(</span><span class="s1">&#39;direction&#39;</span><span class="p">,</span> <span class="s1">&#39;south&#39;</span><span class="p">),</span>
<a name="python--lexicon_tests.py-idio.html-10"></a>                          <span class="p">(</span><span class="s1">&#39;direction&#39;</span><span class="p">,</span> <span class="s1">&#39;east&#39;</span><span class="p">)])</span>
<a name="python--lexicon_tests.py-idio.html-11"></a>
<a name="python--lexicon_tests.py-idio.html-12"></a><span class="k">def</span> <span class="nf">test_verbs</span><span class="p">():</span>
<a name="python--lexicon_tests.py-idio.html-13"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;go&quot;</span><span class="p">),</span> <span class="p">[(</span><span class="s1">&#39;verb&#39;</span><span class="p">,</span> <span class="s1">&#39;go&#39;</span><span class="p">)])</span>
<a name="python--lexicon_tests.py-idio.html-14"></a>    <span class="n">result</span> <span class="o">=</span> <span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;go kill eat&quot;</span><span class="p">)</span>
<a name="python--lexicon_tests.py-idio.html-15"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="p">[(</span><span class="s1">&#39;verb&#39;</span><span class="p">,</span> <span class="s1">&#39;go&#39;</span><span class="p">),</span>
<a name="python--lexicon_tests.py-idio.html-16"></a>                          <span class="p">(</span><span class="s1">&#39;verb&#39;</span><span class="p">,</span> <span class="s1">&#39;kill&#39;</span><span class="p">),</span>
<a name="python--lexicon_tests.py-idio.html-17"></a>                          <span class="p">(</span><span class="s1">&#39;verb&#39;</span><span class="p">,</span> <span class="s1">&#39;eat&#39;</span><span class="p">)])</span>
<a name="python--lexicon_tests.py-idio.html-18"></a>
<a name="python--lexicon_tests.py-idio.html-19"></a>
<a name="python--lexicon_tests.py-idio.html-20"></a><span class="k">def</span> <span class="nf">test_stops</span><span class="p">():</span>
<a name="python--lexicon_tests.py-idio.html-21"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;the&quot;</span><span class="p">),</span> <span class="p">[(</span><span class="s1">&#39;stop&#39;</span><span class="p">,</span> <span class="s1">&#39;the&#39;</span><span class="p">)])</span>
<a name="python--lexicon_tests.py-idio.html-22"></a>    <span class="n">result</span> <span class="o">=</span> <span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;the in of&quot;</span><span class="p">)</span>
<a name="python--lexicon_tests.py-idio.html-23"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="p">[(</span><span class="s1">&#39;stop&#39;</span><span class="p">,</span> <span class="s1">&#39;the&#39;</span><span class="p">),</span>
<a name="python--lexicon_tests.py-idio.html-24"></a>                          <span class="p">(</span><span class="s1">&#39;stop&#39;</span><span class="p">,</span> <span class="s1">&#39;in&#39;</span><span class="p">),</span>
<a name="python--lexicon_tests.py-idio.html-25"></a>                          <span class="p">(</span><span class="s1">&#39;stop&#39;</span><span class="p">,</span> <span class="s1">&#39;of&#39;</span><span class="p">)])</span>
<a name="python--lexicon_tests.py-idio.html-26"></a>
<a name="python--lexicon_tests.py-idio.html-27"></a>
<a name="python--lexicon_tests.py-idio.html-28"></a><span class="k">def</span> <span class="nf">test_nouns</span><span class="p">():</span>
<a name="python--lexicon_tests.py-idio.html-29"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;bear&quot;</span><span class="p">),</span> <span class="p">[(</span><span class="s1">&#39;noun&#39;</span><span class="p">,</span> <span class="s1">&#39;bear&#39;</span><span class="p">)])</span>
<a name="python--lexicon_tests.py-idio.html-30"></a>    <span class="n">result</span> <span class="o">=</span> <span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;bear princess&quot;</span><span class="p">)</span>
<a name="python--lexicon_tests.py-idio.html-31"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="p">[(</span><span class="s1">&#39;noun&#39;</span><span class="p">,</span> <span class="s1">&#39;bear&#39;</span><span class="p">),</span>
<a name="python--lexicon_tests.py-idio.html-32"></a>                          <span class="p">(</span><span class="s1">&#39;noun&#39;</span><span class="p">,</span> <span class="s1">&#39;princess&#39;</span><span class="p">)])</span>
<a name="python--lexicon_tests.py-idio.html-33"></a>
<a name="python--lexicon_tests.py-idio.html-34"></a><span class="k">def</span> <span class="nf">test_numbers</span><span class="p">():</span>
<a name="python--lexicon_tests.py-idio.html-35"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;1234&quot;</span><span class="p">),</span> <span class="p">[(</span><span class="s1">&#39;number&#39;</span><span class="p">,</span> <span class="mi">1234</span><span class="p">)])</span>
<a name="python--lexicon_tests.py-idio.html-36"></a>    <span class="n">result</span> <span class="o">=</span> <span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;3 91234&quot;</span><span class="p">)</span>
<a name="python--lexicon_tests.py-idio.html-37"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="p">[(</span><span class="s1">&#39;number&#39;</span><span class="p">,</span> <span class="mi">3</span><span class="p">),</span>
<a name="python--lexicon_tests.py-idio.html-38"></a>                          <span class="p">(</span><span class="s1">&#39;number&#39;</span><span class="p">,</span> <span class="mi">91234</span><span class="p">)])</span>
<a name="python--lexicon_tests.py-idio.html-39"></a>
<a name="python--lexicon_tests.py-idio.html-40"></a>
<a name="python--lexicon_tests.py-idio.html-41"></a><span class="k">def</span> <span class="nf">test_errors</span><span class="p">():</span>
<a name="python--lexicon_tests.py-idio.html-42"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;ASDFADFASDF&quot;</span><span class="p">),</span> <span class="p">[(</span><span class="s1">&#39;error&#39;</span><span class="p">,</span> <span class="s1">&#39;ASDFADFASDF&#39;</span><span class="p">)])</span>
<a name="python--lexicon_tests.py-idio.html-43"></a>    <span class="n">result</span> <span class="o">=</span> <span class="n">lexicon</span><span class="o">.</span><span class="n">scan</span><span class="p">(</span><span class="s2">&quot;bear IAS princess&quot;</span><span class="p">)</span>
<a name="python--lexicon_tests.py-idio.html-44"></a>    <span class="n">assert_equal</span><span class="p">(</span><span class="n">result</span><span class="p">,</span> <span class="p">[(</span><span class="s1">&#39;noun&#39;</span><span class="p">,</span> <span class="s1">&#39;bear&#39;</span><span class="p">),</span>
<a name="python--lexicon_tests.py-idio.html-45"></a>                          <span class="p">(</span><span class="s1">&#39;error&#39;</span><span class="p">,</span> <span class="s1">&#39;IAS&#39;</span><span class="p">),</span>
<a name="python--lexicon_tests.py-idio.html-46"></a>                          <span class="p">(</span><span class="s1">&#39;noun&#39;</span><span class="p">,</span> <span class="s1">&#39;princess&#39;</span><span class="p">)])</span>
</pre></div>
</td></tr></table><p>You will want to create a new project using the project skeleton just like you did in Exercise 47.  Then you'll need to create this test case and the <tt class="docutils literal">lexicon.py</tt> file it will use.  Look at the top of the test case to see how it's being imported to figure out where it goes.</p>
<p>Next, follow the procedure I gave you and write a little bit of the test case at a time.  For example, here's how I'd do it:</p>
<ol class="arabic simple">
<li>Write the import at the top. Get that to work.</li>
<li>Create an empty version of the first test case <tt class="docutils literal">test_directions</tt>.  Make sure that runs.</li>
<li>Write the first line of the <tt class="docutils literal">test_directions</tt> test case. Make it fail.</li>
<li>Go to the <tt class="docutils literal">lexicon.py</tt> file, create an empty <tt class="docutils literal">scan</tt> function.</li>
<li>Run the test, make sure <tt class="docutils literal">scan</tt> is at least running, even though it fails.</li>
<li>Fill in psuedo code comments for how <tt class="docutils literal">scan</tt> should work to make <tt class="docutils literal">test_directions</tt> pass.</li>
<li>Write the code that matches the comments until <tt class="docutils literal">test_directions</tt> passes.</li>
<li>Go back to <tt class="docutils literal">test_directions</tt> and write the rest of the lines.</li>
<li>Back to <tt class="docutils literal">scan</tt> in <tt class="docutils literal">lexicon.py</tt> and work on it to make this new test code pass.</li>
<li>Once you've done that you have your first passing test, and you move on to the next test.</li>
</ol>
<p>As long as you keep following this procedure one little chunk at a time you can successfully turn a large problem into smaller solvable problems.  It's like climbing a mountain by turning it into a bunch of little hills.</p>
</div>
<div class="section" id="study-drills">
<h1>Study Drills</h1>
<ol class="arabic simple">
<li>Improve the unit test to make sure you test more of the lexicon.</li>
<li>Add to the lexicon and then update the unit test.</li>
<li>Make sure your scanner handles user input in any capitalization and case.  Update the test to make sure this actually works.</li>
<li>Find another way to convert the number.</li>
<li>My solution was 37 lines long.  Is yours longer?  Shorter?</li>
</ol>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<dl class="docutils">
<dt>Why do I keep getting <tt class="docutils literal">ImportErrors</tt>?</dt>
<dd>Import errors are caused by usually four things.  1. You didn't make a <tt class="docutils literal">__init__.py</tt> in a directory that has modules in it.  2. you are in the wrong directory. 3. You are importing the wrong module because you spelled it wrong. 4. Your <tt class="docutils literal">PYTHONPATH</tt> isn't set to <tt class="docutils literal">.</tt> so you can't load modules from your current directory.</dd>
<dt>What's the difference between <tt class="docutils literal"><span class="pre">try-except</span></tt> and <tt class="docutils literal"><span class="pre">if-else</span></tt>?</dt>
<dd>The <tt class="docutils literal"><span class="pre">try-except</span></tt> construct is only used for handling exceptions that modules can throw.  It should <em>never</em> be used as an alternative to <tt class="docutils literal"><span class="pre">if-else</span></tt>.</dd>
<dt>Is there a way to keep the game running while the user is waiting to type?</dt>
<dd>I'm assuming you want to have a monster attack users if they don't react quick enough.  It is possible but it involves modules and techniques that are outside of this book's domain.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex48.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex48.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
